<?php
/**
 * Include and setup custom metaboxes and fields.
 *
 * @category YourThemeOrPlugin
 * @package  Metaboxes
 * @license  http://www.opensource.org/licenses/gpl-license.php GPL v2.0 (or later)
 * @link     https://github.com/jaredatch/Custom-Metaboxes-and-Fields-for-WordPress
 */

add_filter( 'cmb_meta_boxes', 'cmb_sample_metaboxes' );
/**
 * Define the metabox and field configurations.
 *
 * @param  array $meta_boxes
 * @return array
 */
$textdomain = "artha";
function cmb_sample_metaboxes( array $meta_boxes ) {

	// Start with an underscore to hide fields from custom fields list
	$prefix = '_cmb_';
	
  
   
    // Add other metaboxes as needed
    
    $meta_boxes[] = array(
        'id'         => 'post_setting',
        'title'      => 'Post Setting',
        'pages'      => array('post'), // Post type
        'context'    => 'normal',
        'priority'   => 'high',
        'show_names' => true, // Show field names on the left
        //'show_on'    => array( 'key' => 'id', 'value' => array( 2, ), ), // Specific post IDs to display this metabox
        'fields' => array(
             array(
                'name' => 'Blog Image Sidebar',
                'desc' => 'Blog Image Sidebar',
                'id'   => $prefix . 'image_sidebar',
                'type'    => 'file',
            ),
             array(
                'name' => 'Excerpt Sidebar',
                'desc' => 'Excerpt Sidebar',
                'id'   => $prefix . 'excerpt_sidebar',
                'type'    => 'textarea',
            ),
        ),
    );

    $meta_boxes[] = array(
        'id'         => 'post_setting',
        'title'      => 'Post Setting',
        'pages'      => array('works'), // Post type
        'context'    => 'normal',
        'priority'   => 'high',
        'show_names' => true, // Show field names on the left
        //'show_on'    => array( 'key' => 'id', 'value' => array( 2, ), ), // Specific post IDs to display this metabox
        'fields' => array(
            array(
                'name' => 'Detail Project',
                'desc' => 'Detail Project',
                'id'   => $prefix . 'details',
                'type'    => 'select',
                'options'   => array(
                    array( 'value' => 'type1', 'name' => 'Detail Project Sidebar' ),
                    array( 'value' => 'type2', 'name' => 'Detail Project No Sidebar' ),
                    ),
            'placeholder'     => 'Select an Item',
                    ),
             array(
            'name' => 'Project Image 1',
            'desc' => 'Image Slider 1',
            'id'   => $prefix . 'image_slider_1',
            'type' => 'file',
            ),
              array(
            'name' => 'Project Image 2',
            'desc' => 'Image Slider 2',
            'id'   => $prefix . 'image_slider_2',
            'type' => 'file',
            ),
              array(
            'name' => 'Project Image 3',
            'desc' => 'Image Slider 3',
            'id'   => $prefix . 'image_slider_3',
            'type' => 'file',
            ),
              array(
            'name' => 'Project Image 4',
            'desc' => 'Image Slider 4',
            'id'   => $prefix . 'image_slider_4',
            'type' => 'file',
            ),
              array(
            'name' => 'Project Image 5',
            'desc' => 'Image Slider 5',
            'id'   => $prefix . 'image_slider_5',
            'type' => 'file',
            ),
              array(
            'name' => 'Project Image page Home',
            'desc' => 'Project Image page Home',
            'id'   => $prefix . 'image_Home',
            'type' => 'file',
            ),
               array(
            'name' => 'Project Image page Home Pop Up',
            'desc' => 'Project Image page Home Pop Up',
            'id'   => $prefix . 'image_Home_popup',
            'type' => 'file',
            ),
               array(
            'name' => 'Gallery Carousel Image',
            'desc' => 'Gallery Carousel Image',
            'id'   => $prefix . 'image_carousel',
            'type' => 'file',
            ),
              array(
                'name' => 'Select Link',
                'desc' => 'Select Link',
                'id'   => $prefix . 'type',
                'type'    => 'select',
                'options'   => array(
                    array( 'value' => 'type1', 'name' => 'Link Youtube' ),
                    array( 'value' => 'type2', 'name' => 'Link Vim Video' ),
                    array( 'value' => 'type3', 'name' => 'Link Big Video' ),
                    array( 'value' => 'type4', 'name' => 'Link Image' ),
                    ),
            'placeholder'     => 'Select an Item',
                    ),
            array(
                'name' => 'Link Icon Gallery',
                'desc' => 'Link Icon Gallery',
                'id'   => $prefix . 'link',
                'type'    => 'text',
            ),
        ),
    );

    return $meta_boxes;
}

add_action( 'init', 'cmb_initialize_cmb_meta_boxes', 9999 );
/**
 * Initialize the metabox class.
 */
function cmb_initialize_cmb_meta_boxes() {

	if ( ! class_exists( 'cmb_Meta_Box' ) )
		require_once 'init.php';

} 