<?php
/**
Plugin Name: Artha Core
Plugin URI: None
Description: Artha Core
Author: On3step
Author URI: None
Text Domain: artha-core
Version: 0.0.1
*/

class ArthaCore
{
    /**
     * Class Constructor
     */
    public function __construct()
    {
    	add_action( 'init', array( $this, 'register_custom_post_type' ) );

        add_shortcode( 'row', array( $this, 'artha_row' ) );
        add_shortcode( 'col', array( $this, 'artha_col' ) );
        add_shortcode( 'section', array( $this, 'artha_section' ) );
        add_shortcode( 'features', array( $this, 'artha_features' ) );
        add_shortcode( 'box-icon', array( $this, 'artha_box_icon' ) );
        add_shortcode( 'divider-left', array( $this, 'artha_divider_left' ) );
        add_shortcode( 'spacer-single', array( $this, 'artha_spacer_single' ) );
        add_shortcode( 'space-single', array( $this, 'artha_space_single' ) );
        add_shortcode( 'space-single', array( $this, 'artha_space_single' ) );
        add_shortcode( 'carousel', array( $this, 'artha_carousel' ) );
        add_shortcode( 'testimonials', array( $this, 'artha_testimonial' ) );
        add_shortcode( 'cta', array( $this, 'artha_cta' ) );
        add_shortcode( 'brand', array( $this, 'artha_brand' ) );
        add_shortcode( 'brand-item', array( $this, 'artha_brand_item' ) );
        add_shortcode( 'wrap', array( $this, 'artha_wrap' ) );
        add_shortcode( 'count', array( $this, 'artha_count' ) );
        add_shortcode( 'teams', array( $this, 'artha_teams' ) );
        add_action( 'artha_after_the_content', array( $this, 'add_social_share' ), 10, 1 );
    }
    
    function register_custom_post_type() {
		/**
		 * Post Type: Works.
		 */

		$labels = array(
			"name" => __( "Works", "artha-core" ),
			"singular_name" => __( "Work", "artha-core" ),
		);

		$args = array(
			"label" => __( "Works", "artha-core" ),
			"labels" => $labels,
			"description" => "",
			"public" => true,
			"publicly_queryable" => true,
			"show_ui" => true,
			"show_in_rest" => false,
			"rest_base" => "",
			"has_archive" => true,
			"show_in_menu" => true,
			"exclude_from_search" => false,
			"capability_type" => "post",
			"map_meta_cap" => true,
			"hierarchical" => false,
			"rewrite" => array( "slug" => "works", "with_front" => true ),
			"query_var" => true,
			"menu_icon" => "dashicons-hammer",
			"supports" => array( "title", "editor", "thumbnail" ),
		);

		register_post_type( "works", $args );

		/**
		 * Post Type: Teams.
		 */

		$labels = array(
			"name" => __( "Teams", "artha-core" ),
			"singular_name" => __( "Team", "artha-core" ),
		);

		$args = array(
			"label" => __( "Teams", "artha-core" ),
			"labels" => $labels,
			"description" => "",
			"public" => true,
			"publicly_queryable" => true,
			"show_ui" => true,
			"show_in_rest" => false,
			"rest_base" => "",
			"has_archive" => false,
			"show_in_menu" => true,
			"exclude_from_search" => false,
			"capability_type" => "post",
			"map_meta_cap" => true,
			"hierarchical" => false,
			"rewrite" => array( "slug" => "teams", "with_front" => true ),
			"query_var" => true,
			"menu_icon" => "dashicons-groups",
			"supports" => array( "title", "editor", "thumbnail" ),
		);

		register_post_type( "teams", $args );

		/**
		 * Post Type: Testimonies.
		 */

		$labels = array(
			"name" => __( "Testimonies", "artha-core" ),
			"singular_name" => __( "Testimoni", "artha-core" ),
		);

		$args = array(
			"label" => __( "Testimonies", "artha-core" ),
			"labels" => $labels,
			"description" => "",
			"public" => true,
			"publicly_queryable" => true,
			"show_ui" => true,
			"show_in_rest" => false,
			"rest_base" => "",
			"has_archive" => false,
			"show_in_menu" => true,
			"exclude_from_search" => false,
			"capability_type" => "post",
			"map_meta_cap" => true,
			"hierarchical" => false,
			"rewrite" => array( "slug" => "testimonies", "with_front" => true ),
			"query_var" => true,
			"menu_icon" => "dashicons-format-quote",
			"supports" => array( "title", "editor", "thumbnail" ),
		);

		register_post_type( "testimonies", $args );

		/**
		 * Post Type: Services.
		 */

		$labels = array(
			"name" => __( "Services", "artha-core" ),
			"singular_name" => __( "Service", "artha-core" ),
		);

		$args = array(
			"label" => __( "Services", "artha-core" ),
			"labels" => $labels,
			"description" => "",
			"public" => true,
			"publicly_queryable" => true,
			"show_ui" => true,
			"show_in_rest" => false,
			"rest_base" => "",
			"has_archive" => false,
			"show_in_menu" => true,
			"exclude_from_search" => false,
			"capability_type" => "post",
			"map_meta_cap" => true,
			"hierarchical" => false,
			"rewrite" => array( "slug" => "services", "with_front" => true ),
			"query_var" => true,
			"menu_icon" => "dashicons-smiley",
			"supports" => array( "title", "editor", "thumbnail" ),
		);

		register_post_type( "services", $args );

		/**
		 * Taxonomy: Works Tags.
		 */

		$labels = array(
			"name" => __( "Works Tags", "artha-interactive" ),
			"singular_name" => __( "Works Tag", "artha-interactive" ),
		);

		$args = array(
			"label" => __( "Works Tags", "artha-interactive" ),
			"labels" => $labels,
			"public" => true,
			"hierarchical" => false,
			"label" => "Works Tags",
			"show_ui" => true,
			"show_in_menu" => true,
			"show_in_nav_menus" => true,
			"query_var" => true,
			"rewrite" => array( 'slug' => 'works_tag', 'with_front' => true, ),
			"show_admin_column" => false,
			"show_in_rest" => false,
			"rest_base" => "",
			"show_in_quick_edit" => false,
		);
		register_taxonomy( "works_tag", array( "works" ), $args );

		$labels = array(
			"name" => __( "Type", "artha-interactive" ),
			"singular_name" => __( "Type", "artha-interactive" ),
		);

		$args = array(
			"label" => __( "type", "artha-interactive" ),
			"labels" => $labels,
			"public" => true,
			"hierarchical" => false,
			"label" => "Type",
			"show_ui" => true,
			"show_in_menu" => true,
			"show_in_nav_menus" => true,
			"query_var" => true,
			"rewrite" => array( 'slug' => 'type', 'with_front' => true, ),
			"show_admin_column" => false,
			"show_in_rest" => false,
			"rest_base" => "",
			"show_in_quick_edit" => false,
		);
		register_taxonomy( "type", array( "works" ), $args );
	}

    /**
	 * Row
	 */
	public function artha_row( $atts, $content = null ) {
		$atts = shortcode_atts( array(
			'full_width' => 'false',
			'class' => '',
			'fluid' => 'false',
			'nogutter' => 'false',
			'container_class' => ''
		), $atts, 'row' );

		$full_width = $atts['full_width'] == 'true' ? 'row-full-width' : '';
		$container = $atts['fluid'] == 'true' ? 'container-fluid' : 'container';

		if ( $atts['full_width'] == 'true' ) {
			$container .= ' container-full-width';
		}

		$container .= ' ' . $atts['container_class'];

		$output = '<div class="' . esc_attr( $container ) . '">';
		$output .= '<div class="row ' . esc_attr( $atts['class'] ) . '">';

		if ( $atts['nogutter'] == 'true' ) {
			$output .= '<div class="no-gutter">';
		}

		$output .= do_shortcode( $content );

		if ( $atts['nogutter'] == 'true' ) {
			$output .= '</div>';
		}

		$output .= '</div></div>';


		return $output;
	}

	/**
	 * Column
	 */
	public function artha_col( $atts, $content = null ) {
		$atts = shortcode_atts( array(
			'size' => '12',
			'type' => 'md',
			'animate' => 'false',
			'class' => '',
			'dataanim' => '',
			'datatime' => ''
		), $atts, 'col' );

		$attributes = '';
		$classes = '';

		if ( $atts['animate'] == 'true' ) {
			$classes .= ' onStep ';

			if ( $atts['datatime'] != '' ) {
				$attributes .= ' data-time="' . $atts['datatime'] . '"';
			} else {
				$attributes .= ' data-time="0"';
			}

			if ( $atts['dataanim'] != '' ) {
				$attributes .= ' data-animation="' . $atts['dataanim'] . '"';
			} else {
				$attributes .= ' data-animation="fadeInUp"';
			}
		}

		$classes .= $atts['class'];

		$type_col = '';
		if ( $atts['type'] != '' ) {
			$type_col = $atts['type'];
		} else {
			$type_col = 'md';
		}

		$output = '<div class="col-' . esc_attr( $type_col ) . '-' . esc_attr( $atts['size'] ) . ' ' . esc_attr( $classes ) . '"' . $attributes . '>';
		$output .= do_shortcode( $content );
		$output .= '</div>';

		return $output;
	}

	/**
	 * Section
	 */
	public function artha_section( $atts, $content = null ) {
		$atts = shortcode_atts( array(
			'class' => '',
			'id' => '',
			'stretch' => 'false'
		), $atts, 'section' );

		$stretch = '';

		if ( $atts['stretch'] == 'true' ) {
			$stretch = 'stretch';
		}

		return '<section id="' . esc_attr( $atts['id'] ) . '" class="' . esc_attr( $atts['class'] ) . ' ' . esc_attr( $stretch ) . '">' . do_shortcode( $content ) . '</section>';
	}

	/**
	 * Features
	 */
	public function artha_features( $atts, $content = null ) {
		$atts = shortcode_atts( array(
			'bg-image' => '',
			'heading' => '',
			'link' => '#'
		), $atts, 'features' );

		$bg = $atts['bg-image'] != '' ? esc_url( $atts['bg-image'] ) : '';

		$output = '<div class="features no-margin">';

		$output .= '<div class="bg-img" style="background: url(' . $bg . ');">';
		$output .= '<h3 class="heading color">' . esc_html( $atts['heading'] ) . '</h3>';
		$output .= '<p class="content">' . do_shortcode( $content ) . '</p>';
		$output .= '<a href="' . esc_url( $atts['link'] ) . '"><span class="shine"></span>' . __( 'Read More', 'artha-interactive' ) . '</a>';
		$output .= '</div></div>';

		return $output;
	}

	/**
	 * Box icon
	 */
	public function artha_box_icon( $atts, $content = null ) {
		$atts = shortcode_atts( array(
			'icon' => '',
			'title' => ''
		), $atts, 'box-icon' );

		$output = '<div class="box-icon">';
		$output .= '<span class="icon-choose fa ' . esc_attr( $atts['icon'] ) . '"></span>';
		$output .= '<div class="text"><h3><span class="color">' . esc_html( $atts['title'] ) . '</span></h3>';
		$output .= '<p>' . do_shortcode( $content ) . '</p>';
		$output .= '</div></div>';

		return $output;
	}

	/**
	 * Divider left
	 */
	public function artha_divider_left( $atts, $content = null ) {
		return '<span class="divider-left"></span>';
	}

	/**
	 * Spacer single
	 */
	public function artha_spacer_single( $atts, $content = null ) {
		return '<div class="spacer-single"></div>';
	}

	/**
	 * Space single
	 */
	public function artha_space_single( $atts, $content = null ) {
		return '<div class="space-single"></div>';
	}

	public function artha_carousel( $atts, $content ) {
		$atts = shortcode_atts( array(
			'post_type' => 'post',
			'count' => 5,
			'id' => ''
		), $atts, 'carousel' );

		$posts = get_posts( array(
			'post_type' => $atts['post_type'],
			'posts_per_page' => (int)$atts['count'],
			'post_status' => 'publish'
		) );

		ob_start(); ?>

		<div class="onStep" data-animation="fadeInUp" data-time="0">
			<div id="<?php echo esc_attr( $atts['id'] ); ?>" class="owl-carousel">
				<?php foreach ( $posts as $post_entry ): ?>
					<div class="item">
					    <div class="gal-home big-img">
					        <a
					            href="<?php echo esc_url( get_the_post_thumbnail_url( $post_entry->ID ) ); ?>">
					            <div class="hovereffect">
					                <img
					                    alt="imageportofolio"
					                    class="img-responsive"
					                    src="<?php echo get_the_post_thumbnail_url( $post_entry->ID, 'large' ); ?>"/>
					                <div class="overlay">
					                    <h3>
					                        <?php echo esc_html( get_the_title( $post_entry ) ); ?>
					                        <span class="devider">
					                        </span>
					                    </h3>
					                    <p>
					                        <?php echo __( 'More Detail', 'artha-interactive' ); ?>
					                    </p>
					                </div>
					            </div>
					        </a>
					    </div>
					</div>
				<?php endforeach ?>
			</div>
		</div>

		<?php

		return ob_get_clean();
	}


	/**
	 * Testimonial
	 */
	public function artha_testimonial( $atts ) {
		$atts = shortcode_atts( array(
			'count' => 5,
			'id' => 'owl-testimonial'
		), $atts, 'testimonials' );

		extract( $atts );

		$testimonials_query = new WP_Query( array(
			'post_type' => 'testimonies',
			'posts_per_page' => (int)$count,
			'post_status' => 'publish'
		) );

		ob_start(); ?>
		<div class="image-container col-lg-6 pull-right hidden-md hidden-sm hidden-xs onStep" data-animation="fadeInRight" data-time="300"></div>
		<div class="col-lg-6 col-md-12 p-90">
	        <div class="space-half hidden-md hidden-sm hidden-xs"></div>
			<?php if ( $testimonials_query->have_posts() ): ?>
				<?php global $post; ?>
				<div id="owl-testimonial" class="owl-carousel owl-theme">
					<?php while ( $testimonials_query->have_posts() ) : $testimonials_query->the_post(); ?>
						<div class="item">
						    <blockquote><?php echo get_the_content(); ?></blockquote>
						    <img alt="imagetesti" class="tal" src="<?php the_post_thumbnail_url(); ?>"/>
						    <h3><?php the_title(); ?></h3>
						</div>
					<?php endwhile; ?>
				</div>
				<?php wp_reset_postdata(); ?>
			<?php endif ?>
		</div>
		<?php

		return ob_get_clean();
	}

	/**
	 * CTA
	 */
	public function artha_cta( $atts, $content = null ) {
		$atts = shortcode_atts( array(
			'url' => '',
			'link_text' => ''
		), $atts, 'cta' );

		ob_start(); ?>
		<div class="col-lg-9 col-md-12 text-center">
	        <h3>
	            <?php echo do_shortcode( $content ); ?>
	        </h3>
	    </div>
	    <div class="col-lg-3 col-md-12">
	        <div class="btn-content">
	            <span class="shine">
	            </span>
	            <a href="<?php echo esc_url( $atts['url'] ); ?>">
	                <?php echo esc_html( $atts['link_text'] ); ?>
	            </a>
	        </div>
	    </div>
		<?php

		return ob_get_clean();
	}

	/**
	 * Brand
	 */
	public function artha_brand( $atts, $content = null )
	{
		$atts = shortcode_atts( array(
			'id' => 'owl-brand'
		), $atts, 'brand' );

		ob_start(); ?>
		<div id="<?php echo esc_attr( $atts['id'] ); ?>" class="owl-carousel">
			<?php echo do_shortcode( $content ); ?>
		</div>
		<?php

		return ob_get_clean();
	}

	/**
	 * Brand item
	 */
	public function artha_brand_item( $atts, $content = null )
	{
		$atts = shortcode_atts( array(
			'img' => 'http://themeonstep.com/tf/artha/main/html/img/ourclients/1.png'
		), $atts, 'brand-item' );
		ob_start(); ?>

		<div class="item">
			<img src="<?php echo esc_url( $atts['img'] ); ?>" alt="background">
		</div>
		<?php

		return ob_get_clean();
	}

	/**
	 * Artha wrap
	 */
	public function artha_wrap( $atts, $content = null )
	{
		$atts = shortcode_atts( array(
			'class' => ''
		), $atts, 'wrap' );

		ob_start(); ?>
		<div class="<?php echo esc_attr( $atts['class'] ) ?>">
			<?php echo do_shortcode( $content ); ?>
		</div>
		<?php

		return ob_get_clean();
	}

	/**
	 * Count
	 */
	public function artha_count( $atts, $content = null )
	{
		$atts = shortcode_atts( array(
			'num' => '100',
			'title' => ''
		), $atts, 'count' );

		ob_start(); ?>
		<div class="count-about">
			<span class="numb"><?php echo esc_html( $atts['num'] ); ?></span>
			<span class="detail"><?php echo esc_html( $atts['title'] ); ?></span>
		</div>
		<?php

		return ob_get_clean();
	}

	/**
	 * Team
	 */
	public function artha_teams( $atts, $content = null )
	{
		$atts = shortcode_atts( array(
			'show' => -1
		), $atts, 'teams' );

		$teams = get_posts( array(
			'post_type' => 'teams',
			'post_status' => 'publish',
			'posts_per_page' => (int) $atts['show']
		) );

		ob_start();
		?>
		<div class="owl-carousel" id="owl-team">
			<?php foreach ( $teams as $team ): ?>
				<div class="item">
				    <div class="team" style="background-image: url(<?php echo get_the_post_thumbnail_url( $team->ID, 'full' ); ?>);">
				        <div class="hovereffect">
				            <div class="overlay-2">
				                <div class="content">
				                    <div class="heading">
				                        <?php echo get_the_title( $team->ID ); ?>
				                        <span class="devider-recent-2">
				                        </span>
				                    </div>
				                    <div class="subheading">
				                        <?php echo get_field('position', $team->ID) ?>
				                    </div>
				                    <div class="social-icons">
				                    <?php if (get_field('facebook', $team->ID)) : ?>
				                        <a href="<?php get_field('facebook', $team->ID) ?>">
				                            <span class="ti-facebook">
				                            </span>
				                        </a>
				                    <?php endif; ?>
				                    <?php if (get_field('dribbble', $team->ID)) : ?>
				                        <a href="<?php echo get_field('dribbble', $team->ID) ?>">
				                            <span class="ti-dribbble">
				                            </span>
				                        </a>
				                    <?php endif; ?>
				                    <?php if(get_field('twitter', $team->ID)) : ?>
				                        <a href="<?php echo get_field('twitter', $team->ID) ?>">
				                            <span class="ti-twitter">
				                            </span>
				                        </a>
				                    <?php endif; ?>
				                    </div>
				                </div>
				            </div>
				        </div>
				    </div>
				</div>
			<?php endforeach ?>
		</div>
		<?php

		return ob_get_clean();
	}

	/**
	 * Add social share buttons
	 * 
	 * @return void
	 */
	public function add_social_share( $post_ID )
	{
		?>

		<div class="post-share">
			<span><?php echo __( 'Share: ', 'artha-interactive' ); ?></span>
			<ul class="share-list">
				<li>
					<a href="https://www.facebook.com/sharer/sharer.php?u=<?php echo urlencode( get_permalink() ); ?>&amp;t=<?php echo get_the_title(); ?>" onclick="javascript:window.open(this.href, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=300,width=600');return false;" target="_blank" title="Share on Facebook"><i class="fa fa-facebook"></i></a>
				</li>
				<li>
					<a href="https://twitter.com/share?url=<?php echo urlencode( get_permalink() ); ?>&amp;via=<?php bloginfo( 'name' ); ?>&amp;text=<?php echo __( 'Read userful article', 'artha-interactive' ); ?>" onclick="javascript:window.open(this.href, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=300,width=600');return false;" target="_blank" title="Share on Twitter"><i class="fa fa-twitter"></i></a>
				</li>
				<li>
					<a href="https://plus.google.com/share?url=<?php echo urlencode( get_permalink() ); ?>" onclick="javascript:window.open(this.href, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=350,width=480');return false;" target="_blank" title="Share on Google+"><i class="fa fa-google"></i></a>
				</li>
				<li>
					<a href="https://www.linkedin.com/shareArticle?mini=true&amp;url=<?php echo urlencode( get_permalink() ); ?>&amp;title=AUTUMN COLLECTION GIFT BOX – SOLD OUT&amp;summary=<?php __( 'Read useful article', 'artha-interactive' ); ?>&amp;source=<?php bloginfo( 'name' ); ?>" onclick="javascript:window.open(this.href, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=350,width=480');return false;" target="_blank"><i class="fa fa-linkedin"></i></a>
				</li>
			</ul>
		</div>
		<?php
	}
}

$arthaCore = new ArthaCore();